/*************************************************************
Generated for Telelogic Tau 4.2.0.2.13177 at Mon Apr 20 18:35:17 CEST 2009
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2008.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torThreadSafeEventQueue_h__
#define __torThreadSafeEventQueue_h__ (1)

#include "torPlatform.h"

#include "torEventQueue.h"
#include "torOs.h"

namespace tor 
{
    class Event;
    class Dispatchable;

    class TOR_EXT_DEF ThreadSafeEventQueue : public EventQueue 
    {
    public:
        ThreadSafeEventQueue();
        virtual ~ThreadSafeEventQueue();

        void insert(Event *event);
        bool remove(Event *event);        

        Event *get();
        Event *get(os::Time timeout);
        
        bool empty() const;

    private:
        mutable os::Mutex m_mutex;
        mutable os::Semaphore m_read;
    };

} // tor namespace

#endif  // __torThreadSafeEventQueue_h__

